/* test.h -- Test Interface
   Copyright 2001 Free Software Foundation, Inc.
   Written by Stephane Carrez (stcarrez@worldnet.fr)

This file is part of GEL.

GEL is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GEL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GEL; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef _GEL_TEST_H
#define _GEL_TEST_H

#include <sys/param.h>

#ifdef __cplusplus
extern "C" {
#endif

/*! @defgroup test Test Interface

 */
/*@{*/

/*! Test case failed.  */
extern int test_error (const char *message, ...);

extern void test_depend (const char *depend);
  
/*! Returns the status of the test.  */
extern int test_status (void);

extern void test_start (const char *name);
  
extern int test_end (const char *name);
  
extern int test_repeat;
  
/*@}*/

#ifdef __cplusplus
};
#endif
#endif
