/* gdm-circle.c -- Circle Drawing
   Copyright 2003 Free Software Foundation, Inc.
   Written by Stephane Carrez (stcarrez@nerim.fr)

This file is part of GEL.

GEL is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GEL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GEL; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <gdm/display.h>
#include <gdm/display-raw.h>

static void
circle_plot (gdm_display* dp, short x0, short y0, short x, short y)
{
  gdm_draw_point (dp, x0 + x, y0 + y);
  gdm_draw_point (dp, x0 + x, y0 - y);
  gdm_draw_point (dp, x0 - x, y0 + y);
  gdm_draw_point (dp, x0 - x, y0 - y);
  gdm_draw_point (dp, x0 + y, y0 + x);
  gdm_draw_point (dp, x0 + y, y0 - x);
  gdm_draw_point (dp, x0 - y, y0 + x);
  gdm_draw_point (dp, x0 - y, y0 - x);
}

void
gdm_draw_circle (gdm_display* dp, short x0, short y0, short r)
{
  short x = 0;
  short y = r;
  short dx = y;

  while (y > x)
    {
      circle_plot (dp, x0, y0, x, y);
      dx = dx + 2 * x + 1;
      if ((dx >= 0 && dx >= 2 * y) || (dx < 0 && -dx >= 2 * y))
        {
          dx = dx - 2 * y + 1;
          y--;
        }
      x++;
    }
  if (x == y)
    circle_plot (dp, x0, y0, x, y);
}
