/* timer-test.c -- Test of timer and LCD
   Copyright 2000 Free Software Foundation, Inc.
   Written by Stephane Carrez (stcarrez@worldnet.fr)

This file is part of EBCS.

EBCS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

EBCS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with EBCS; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <sys/param.h>
#include <sys/locks.h>
#include <gel/timer.h>
#include <sys/sio.h>
#include <benchs.h>
#include <time.h>
#include <test.h>

/* Forward declarations.  */
void udelay_benchs (void);


void
udelay_benchs ()
{
  bench_t b;

  bench_init (&b);

  bench_start (&b);
  udelay (10);
  bench_stop (&b);
  bench_report (&b, "udelay (10)");

  bench_start (&b);
  udelay (100);
  bench_stop (&b);
  bench_report (&b, "udelay (100)");

  bench_start (&b);
  udelay (1000);
  bench_stop (&b);
  bench_report (&b, "udelay (1000)");
  
  bench_start (&b);
  udelay (10000);
  bench_stop (&b);
  bench_report (&b, "udelay (10000)");
}

int
main()
{
  serial_init ();
  test_depend ("serial");
  test_start ("udelay-test");

  udelay_benchs ();
  return test_end ("udelay-test");
}
